function x = ct_fast_oopsi(x, handles, options)
% This function prepares and runs fast oopsi on the traces as a
% preprocessor in caltracer.

rawF=x;
Ncells = size(rawF,1);

V.dt=handles.app.experiment.timeRes;
P.lam=options.P.lam.value;
V.posspiketimes = 500:options.brpoints.value:size(rawF,2);
tau=1;
P.gam = (1-V.dt/tau)';
P.a = 1.5;

spikes = cell(size(rawF,1),1); % spike inference output vector
struct = cell(size(rawF,1),1); % spike inference output struct
indices = ones(size(rawF,1),1);
n = zeros(size(rawF,2),1);
x = zeros(size(rawF));
for i = 1:size(rawF, 1)
    fprintf('\nneuron %d\n',i);
    Fcell = rawF(i,:);
    Fcell = detrend(Fcell,'linear',V.posspiketimes);
    Fcell=Fcell-min(Fcell); Fcell=Fcell/max(Fcell); Fcell=Fcell+eps;
    P.b = median(Fcell);
    fprintf('running spike inference...\n');
    
    [n test.P test.V]= fast_oopsi(Fcell,V,P);
        
        struct{i}.P = test.P;
        struct{i}.n = n;
        spikes{i}=struct{i}.n;
        spikes{i}=spikes{i}/max(spikes{i});
        x(i,:)=spikes{i};
        V.F{i}=Fcell(1,:);   
end